package v5.name.panitz.wip;

import v5.name.panitz.wip.Tree.FieldSelect;
import v5.name.panitz.wip.Tree.FunCall;
import v5.name.panitz.wip.Tree.FunDef;
import v5.name.panitz.wip.Tree.Program;
import v5.name.panitz.wip.Tree.Variable;

public interface Visitor<R> {
	R visit(Tree.IntLiteral il);
	R visit(Tree.OpExpr oe);
	R visit(FunDef funDef);
	R visit(Tree.ConDef conDef);
	R visit(Tree.Param param);
	R visit(Program program);
	R visit(Variable variable);
	R visit(FunCall funCall);
	R visit(FieldSelect fieldSelect);
}
